VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "DPLOTLIB Test"
   ClientHeight    =   5250
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2925
   LinkTopic       =   "Form1"
   ScaleHeight     =   5250
   ScaleWidth      =   2925
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command7 
      Caption         =   "3D Scatter Plot"
      Height          =   495
      Left            =   120
      TabIndex        =   6
      Top             =   4440
      Width           =   2655
   End
   Begin VB.CommandButton Command6 
      Caption         =   "XY Plot (polar)"
      Height          =   495
      Left            =   120
      TabIndex        =   5
      Top             =   3720
      Width           =   2655
   End
   Begin VB.CommandButton Command5 
      Caption         =   "Surface plot w/ Concave Edges"
      Height          =   495
      Left            =   120
      TabIndex        =   4
      Top             =   3000
      Width           =   2655
   End
   Begin VB.CommandButton Command4 
      Caption         =   "Box-and-Whisker Plot (1D)"
      Height          =   495
      Left            =   120
      TabIndex        =   3
      Top             =   2280
      Width           =   2655
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Contour Plot - Random Data"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1560
      Width           =   2655
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Contour Plot - Gridded Data"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   2655
   End
   Begin VB.CommandButton Command1 
      Caption         =   "XY Plot"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2655
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 0
Dim d As DPLOT

Private Sub Command1_Click()

    Dim i As Long
    Dim NP As Long
    Dim X() As Single
    Dim Y() As Single
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    Dim DocNum As Long
    
' Plot sin(PI*x) and cos(PI*x) from x = 0 to 4.
' In this case we've used DATA_XYYY (one X array for one or more Y arrays).
'
' Since the X values are evenly spaced we could also use
' DATA_DXY  - X has only 2 elements, DX and X0
'
' And you can ALWAYS use
' DATA_XYXY - Each curve uses its own X array. This is the only
'             option available if the curves have different X values or
'             a different number of points.
    PI = 4# * Atn(1#)
    NP = 4001
    ReDim X(0 To NP - 1) As Single
    ReDim Y(0 To 2 * NP - 1) As Single
    
    For i = 0 To NP - 1
        X(i) = (4# * i) / (NP - 1)
        Y(i) = Sin(PI * X(i))
        Y(i + NP) = Cos(PI * X(i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_XYYY
    d.MaxCurves = 2         ' Must be >= number of curves we plot
    d.MaxPoints = NP        ' Anything >= NP will do
    d.NumCurves = 2
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.LegendX = 0.05
    d.LegendY = 0.05
    d.NP(0) = NP
    d.NP(1) = NP
    d.LineType(0) = LINESTYLE_SOLID
    d.LineType(1) = LINESTYLE_LONGDASH
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = ""
    d.Title3 = ""
    d.XAxis = "x" & Chr$(0)
    d.YAxis = "y" & Chr$(0)
        
' The command string can be as complex as you like, limited to 32K characters.
' As an alternative, if your program will be producing many similar plots then
' you might prefer to create a preferences file, edit the file with a text
' editor to remove unwanted entries, and use the [GetPreferences("filename")]
' command.
    cmds = "[ManualScale(0,-1.25,4,1.25)][TickInterval(1,0.5,0.25)]"
    cmds = cmds & "[Caption(""DPLOTLIB XY Test"")]"
    cmds = cmds & "[Legend(1,""sin({\sp}x)"")]"
    cmds = cmds & "[Legend(2,""cos({\sp}x)"")]"
    cmds = cmds & "[ClearEditFlag()][DocMaximize()]"
    DocNum = DPlot_Plot(d, X(0), Y(0), cmds)
 
End Sub

Private Sub Command2_Click()
    Dim i, j As Long
    Dim Nx As Long      ' Number of data columns (horizontal grid cells+1)
    Dim Ny As Long      ' Number of data rows (vertical grid cells+1)
    Dim extents(3) As Single
    Dim Z() As Single
    Dim X As Single
    Dim Y As Single
    Dim cmds As String
    Dim ret As Long
    
    Nx = 61
    Ny = 41
    ReDim Z(Nx * Ny - 1) As Single
    extents(0) = -3     ' xlo
    extents(1) = -2     ' ylo
    extents(2) = 3      ' xhi
    extents(3) = 2      ' yhi
    
    For i = 0 To Nx - 1
        X = extents(0) + ((extents(2) - extents(0)) * i) / (Nx - 1)
        For j = 0 To Ny - 1
            Y = extents(1) + ((extents(3) - extents(1)) * j) / (Ny - 1)
            Z(i * Ny + j) = Sin(X) * Cos(Y)
        Next j
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_3D
    d.MaxCurves = Nx - 1
    d.MaxPoints = Ny - 1
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Caption(""DPLOTLIB Contour Test 1"")]"
    cmds = cmds & "[Contour3D(1)][ContourGrid(1)][ContourAxes(1)]"
    cmds = cmds & "[ContourView(30,20)][ContourLevels(20,-1,1)]"
    cmds = cmds & "[ContourScales(1,1,1)]"
    cmds = cmds & "[FontPoints(1,10)][FontPoints(6,10)]"
    cmds = cmds & "[ZAxisLabel(""z"")]"
    cmds = cmds & "[DocMaximize()]"
    
    ret = DPlot_Plot(d, extents(0), Z(0), cmds)

End Sub

Private Sub Command3_Click()
'
'   Sends randomly-placed x,y,z triplets to DPlot and produces a
'   contour plot. The random feature of this example is a bit nonsensical
'   since we're using an equation to generate the data. This DPlot feature
'   is much more useful for truly random data and/or data values that
'   aren't organized on a rectangular grid.
'
    Dim Node() As Single
    Dim i As Long
    Dim Nz As Long
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    
    PI = 4# * Atn(1#)
    Nz = 1000
    ReDim Node(2, Nz - 1)
    
    For i = 0 To Nz - 1
        Node(0, i) = -PI + 2 * PI * Rnd
        Node(1, i) = -PI + 2 * PI * Rnd
        Node(2, i) = Sin(Node(0, i)) * Cos(Node(1, i))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_3DR
    d.MaxCurves = 1
    d.MaxPoints = Nz
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = "z = sin(x)*cos(y)"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Caption(""DPLOTLIB Contour Test 2"")]"
    cmds = cmds & "[ContourAxes(1)][ContourGrid(0)][ContourLevels(21,-1,1)]"
    cmds = cmds & "[FontPoints(1,10)][FontPoints(6,10)][DocMaximize()]"
    ret = DPlot_Plot(d, 0&, Node(0, 0), cmds)

End Sub

Private Sub Command4_Click()
    Dim i, j, k As Long
    Dim Ny As Long
    Dim Y() As Single
    Dim cmds As String
    Dim ret As Long
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_1D
    d.MaxCurves = 3
    d.MaxPoints = 80
    d.NumCurves = 3
    d.LegendX = 0.02
    d.LegendY = 0.7
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Data sent to DPlot via DPLOTLIB.DLL"
    d.Title2 = ""
    d.Title3 = ""
    d.YAxis = "Amplitude"
    
    ' Number of points in each group is 50 +/- 15:
    Ny = 0
    For i = 0 To d.NumCurves - 1
        d.NP(i) = 50 + 30 * (Rnd - 0.5)
        Ny = Ny + d.NP(i)
        Mid(d.Legend, (i + 1) * 80 + 1, 80) = "Group " & Chr$(65 + i)
    Next i

    ' Generate group data, centered around 5.0 with progressively larger variations
    ReDim Y(Ny - 1) As Single
    k = 0
    For i = 0 To d.NumCurves - 1
        For j = 0 To d.NP(i) - 1
            Y(k) = 5# + (i + 1) * (-0.5 + Rnd)
            k = k + 1
        Next j
    Next i
        
    cmds = "[Caption(""DPLOTLIB Box-and-whisker Test"")]"
    cmds = cmds & "[Stat_PlotType(0)][Stat_GroupInfo(15,4)]"
    cmds = cmds & "[Stat_BWOptions(1,1,0,1,1.5,2,3)]"
    cmds = cmds & "[Stat_GrandMean(3,30)]"
    cmds = cmds & "[FontPoints(1,10)][FontPoints(6,10)]"
    cmds = cmds & "[DocMaximize()]"
    ret = DPlot_Plot(d, 0&, Y(0), cmds)

End Sub

Private Sub Command5_Click()
'
'   Sends x,y,z triplets defining the outline of a star to DPlot. Initially
'   the resulting surface plot will be convex, in this case a pentagon. We'll
'   then define the border using DPlot_3DBorder so that the plot is
'   star-shaped.
'
    Dim Star(2, 9) As Double
    Dim Border(1, 9) As Double
    Dim x0, y0, side As Double
    Dim i As Long
    Dim Nz As Long
    Dim PI As Single
    Dim cmds As String
    Dim DocNum As Long
    Dim ret As Long
    
    PI = 4# * Atn(1#)
    
    x0 = 0      ' Center of the star
    y0 = 0
    side = 1    ' Distance between star points

    Star(0, 0) = x0 - 0.5 * side
    Star(1, 0) = y0 - 0.5 * side * Tan(54 * PI / 180)
    Star(2, 0) = 0#
    Star(0, 1) = x0
    Star(1, 1) = Star(1, 0) + 0.5 * side * Tan(36 * PI / 180)
    Star(2, 1) = 1#
    Star(0, 2) = x0 + 0.5 * side
    Star(1, 2) = Star(1, 0)
    Star(2, 2) = 0#
    Star(0, 3) = Star(0, 2) - 0.5 * side * (Sin(18 * PI / 180) / Cos(36 * PI / 180))
    Star(1, 3) = Star(1, 2) + 0.5 * side * (Cos(18 * PI / 180) / Cos(36 * PI / 180))
    Star(2, 3) = 1#
    Star(0, 4) = Star(0, 2) + side * Sin(18 * PI / 180)
    Star(1, 4) = Star(1, 2) + side * Cos(18 * PI / 180)
    Star(2, 4) = 0#
    Star(0, 5) = x0 + 0.5 * side * (Sin(18 * PI / 180) / Cos(36 * PI / 180))
    Star(1, 5) = Star(1, 4)
    Star(2, 5) = 1#
    Star(0, 6) = x0
    Star(1, 6) = Star(1, 4) + side * Sin(36 * PI / 180)
    Star(2, 6) = 0#
    Star(0, 7) = 2 * x0 - Star(0, 5)
    Star(1, 7) = Star(1, 5)
    Star(2, 7) = 1#
    Star(0, 8) = 2 * x0 - Star(0, 4)
    Star(1, 8) = Star(1, 4)
    Star(2, 8) = 0#
    Star(0, 9) = 2 * x0 - Star(0, 3)
    Star(1, 9) = Star(1, 3)
    Star(2, 9) = 1#
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_3DR
    d.MaxCurves = 1
    d.MaxPoints = 10
    d.NumCurves = 1
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "Surface Plot with Concave Edges"
    d.Title2 = "See {\iDefine Boundary} Command on {\iOptions} menu"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
        
    cmds = "[Caption(""DPLOTLIB Surface Plot w/ Concave Edges"")]"
    cmds = cmds & "[ContourAxes(1)][ContourGrid(0)][ContourMethod(0)][ContourLevels(20,0,1)]"
    cmds = cmds & "[FontPoints(1,10)][FontPoints(6,10)][DocMaximize()]"
    DocNum = DPlot_Plot8(d, 0&, Star(0, 0), cmds)
    If DocNum > 0 Then
       For i = 0 To 9
          Border(0, i) = Star(0, i)
          Border(1, i) = Star(1, i)
       Next i
       ret = DPlot_3DBorder(DocNum, 10, Border(0, 0))
    End If

End Sub
Private Sub Command6_Click()

    Dim i As Long
    Dim NP As Long
    Dim X() As Single
    Dim Y() As Single
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    Dim DocNum As Long
    
' Plot sin(3*x) from x = 0 to 2PI
' In this case we've used DATA_XYYY (one X array for one or more Y arrays).
'
' Since the X values are evenly spaced we could also use
' DATA_DXY  - X has only 2 elements, DX and X0
'
' And you can ALWAYS use
' DATA_XYXY - Each curve uses its own X array. This is the only
'             option available if the curves have different X values or
'             a different number of points.
        
    PI = 4# * Atn(1#)
    NP = 1001
    ReDim X(0 To NP - 1) As Single
    ReDim Y(0 To NP - 1) As Single
    
    For i = 0 To NP - 1
        X(i) = (2# * PI * i) / (NP - 1)
        Y(i) = Abs(Sin(3 * X(i)))
    Next i
        
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_XYYY
    d.MaxCurves = 1         ' Must be >= number of curves we plot
    d.MaxPoints = NP        ' Anything >= NP will do
    d.NumCurves = 1
    d.ScaleCode = SCALE_POLAR
    d.NP(0) = NP
    d.LineType(0) = LINESTYLE_SOLID
    d.Title1 = "abs(sin(3{\sf}))"
    d.Title2 = ""
    d.Title3 = ""
        
    cmds = "[ManualScale(0,0,0,1.2)]"                 ' X limits are ignored
    cmds = cmds & "[TickInterval(2,30,0.2)]"            ' 1st "2" says X interval is in degrees
    cmds = cmds & "[Caption(""DPLOTLIB XY Test"")]"
    cmds = cmds & "[PolarPlotStyle(7)]"
    cmds = cmds & "[NumberFormat(0,8)]"                 ' PI Fractions
    cmds = cmds & "[ClearEditFlag()][DocMaximize()]"
    DocNum = DPlot_Plot(d, X(0), Y(0), cmds)
 
End Sub

Private Sub Command7_Click()
'
'   3D scatter plot. This example generates data points on the surface of
'   3 spheres and sends the data to DPlot as 3 separate sets.
'
    Dim Node() As Double
    Dim i As Long
    Dim j As Long
    Dim k As Long
    Dim Ntotal As Long
    Dim PI As Single
    Dim cmds As String
    Dim ret As Long
    Dim xmin As Double
    Dim xmax As Double
    Dim ymin As Double
    Dim ymax As Double
    Dim zmin As Double
    Dim zmax As Double
    Dim phi As Double
    Dim theta As Double
    Dim theta_inc As Double
    Dim xcenter As Double
    Dim ycenter As Double
    Dim zcenter As Double
    Dim radius As Double
    
    PI = 4# * Atn(1#)
'
'   3 data sets each with a random number of data points between
'   500 and 1500:
'
    d.MaxCurves = 3
    d.NumCurves = 3
    d.NP(0) = 500 + 1000 * Rnd
    d.NP(1) = 500 + 1000 * Rnd
    d.NP(2) = 500 + 1000 * Rnd
    
    Ntotal = d.NP(0) + d.NP(1) + d.NP(2)
    ReDim Node(2, Ntotal - 1)
'
'   Keep track of the minimum and maximum X,Y, and Z values so we can
'   force plot extents to good values, "good" in this case being
'   whole numbers.
'
    xmin = xmax = 0
    ymin = ymax = 0
    zmin = zmax = 0
    
    k = 0       ' index into Node array
    For i = 0 To d.NumCurves - 1
'       Center of each sphere is at some random location between
'       (-5,-5,-5) and (5,5,5).
        xcenter = -5 + 10 * Rnd
        ycenter = -5 + 10 * Rnd
        zcenter = -5 + 10 * Rnd
'       Radii are proportional to number of points
        radius = 0.005 * d.NP(i)
        If xmin > xcenter - radius Then xmin = xcenter - radius
        If xmax < xcenter + radius Then xmax = xcenter + radius
        If ymin > ycenter - radius Then ymin = ycenter - radius
        If ymax < ycenter + radius Then ymax = ycenter + radius
        If zmin > zcenter - radius Then zmin = zcenter - radius
        If zmax < zcenter + radius Then zmax = zcenter + radius
'       increment in theta (angle around z axis) gives roughly
'       equal spacing between points in all directions:
        theta_inc = 2# * Sqr(CDbl(d.NP(i)))
        For j = 0 To d.NP(i) - 1
            phi = -PI / 2 + PI * CDbl(j) / CDbl(d.NP(i))
            theta = theta_inc * PI * CDbl(j) / CDbl(d.NP(i))
            Node(0, k) = xcenter + (radius * Cos(theta) * Cos(phi))
            Node(1, k) = ycenter + (radius * Sin(theta) * Cos(phi))
            Node(2, k) = zcenter + (radius * Sin(phi))
            k = k + 1
        Next j
    Next i
            
    d.version = DPLOT_DDE_VERSION
    d.DataFormat = DATA_3DS
    d.MaxPoints = 1500
    d.ScaleCode = SCALE_LINEARX_LINEARY
    d.Title1 = "DPLOTLIB - Points on Spheres"
    d.Title3 = ""
    d.XAxis = "x"
    d.YAxis = "y"
    cmds = "[Caption(""DPLOTLIB - Points on Spheres"")]"
    cmds = cmds & "[TickInterval(1,1,1,1)][ContourAxes(1)]"
    cmds = cmds & "[ColorBasis(1)][ContourColorScheme(2)]"
    cmds = cmds & "[ContourCustomColors(255,65280,16711680)][ContourScales(1,1,1)]"
    cmds = cmds & "[ZAxisLabel(""z"")]"
    cmds = cmds & "[ManualScale(" & Str$(CLng(xmin)) & ","
    cmds = cmds & Str$(CLng(ymin)) & ","
    cmds = cmds & Str$(CLng(xmax)) & ","
    cmds = cmds & Str$(CLng(ymax)) & ","
    cmds = cmds & Str$(CLng(zmin)) & ","
    cmds = cmds & Str$(CLng(zmax)) & ")]"
    cmds = cmds & "[Legend(0,""Legend"")]"
    cmds = cmds & "[Legend(1,""Sphere 1"")]"
    cmds = cmds & "[Legend(2,""Sphere 2"")]"
    cmds = cmds & "[Legend(3,""Sphere 3"")]"
    cmds = cmds & "[FontPoints(1,10)][FontPoints(6,10)][DocMaximize()]"
    ret = DPlot_Plot8(d, 0&, Node(0, 0), cmds)
End Sub

Private Sub Form_Load()
'
'   Ideally DPLOTLIB.DLL should reside in the same folder as your
'   compiled executable. Within the VB environment, though, finding
'   DPLOTLIB.DLL is a bit more problematic. The subroutine DPlot_FindDPLOTLIB
'   will search the registry for its location, then change the
'   working directory to that folder so that VB (actually Windows) will
'   find it.
'
    Call DPlot_FindDPLOTLIB
    DPlot_SetErrorMethod (2)
End Sub

